#include "SegDWT.h"
#include <cstring>
#include <cstdio>
#include <cmath>



	void FloatSegDWT::forwardOLA(float* in, int inLen,
					float* out[],int outLen[],
					float* outOverlap[],int outOverlapLen[]){
	// to be implemented soon. Maybe..
	}

	void FloatSegDWT::forwardOLS(float* in,int inLen,
								float* out[],int outLen[],
								unsigned long Sn){

		
		// skip denotes initial skip for convolution
		int skip = 1;
		if(Sn!=0) skip=wavelet->filtLen-1;
		// allocation of subbands
		reAllocateInSubbands(out,outLen,Sn,inLen,J);
		reAllocateOutSubbands(coefOutMod,coefOutModLen,Sn,inLen,J);

		int leftExt = leftExtNoRight(Sn,wavelet->filtLen,J);
		
		// in the worst case scanario, ensure wavelet->filtLen-1 zero samples at the end
		if(tempInLenMax < inLen + maxLeftExt + wavelet->filtLen-1){
			if(tempIn) free(tempIn);
			tempInLenMax = inLen + maxLeftExt + wavelet->filtLen-1;
			tempIn = (float*) malloc(tempInLenMax*sizeof(float));
		} 
		memset(tempIn,0,tempInLenMax*sizeof(float));
		tempInLen = inLen + leftExt;

		// copy last leftExt samples form prev, in case of leftExt > prevLen, additional zeros are used
	
		if(leftExt!=0) memcpy(tempIn,prev + prevLen - leftExt,(leftExt)*sizeof(float));
		memcpy(tempIn+leftExt,in,inLen*sizeof(float));

		if(J==1){
			convSub(tempIn,tempInLen,out[1],out[0],outLen[1],wavelet->lo_a,wavelet->hi_a,wavelet->filtLen,skip);
			
		}else{

			// allocation of helper arrays to hold intermediate coefficients
			// 
			int toDiscard = discardLeftExtNoRight(Sn,wavelet->filtLen,J,1);

			if(tempALenMax < (inLen + maxLeftExt + wavelet->filtLen-1)/2){
				if(tempA) free(tempA);
				if(tempD) free(tempD);
				tempALenMax = (inLen + maxLeftExt + wavelet->filtLen-1)/2;
				tempA = (float*) malloc(tempALenMax*sizeof(float));
				tempD = (float*) malloc(tempALenMax*sizeof(float));
			} 
			memset(tempA,0,tempALenMax*sizeof(float));
			memset(tempD,0,tempALenMax*sizeof(float));

			tempALen = outLen[0] + toDiscard;
			convSub(tempIn,tempInLen,tempA,tempD,tempALen,wavelet->lo_a,wavelet->hi_a,wavelet->filtLen,skip);
			// copy to output, tempA holds intermediate approx. coefs
			memcpy(out[0],tempD+toDiscard,outLen[0]*sizeof(float)); 
			int tempALenPrev = tempALen;

			for (int j = 1; j < J-1; j++) {
				if(outLen[j] == 0) return;
				toDiscard = discardLeftExtNoRight(Sn,wavelet->filtLen,J,j+1);
				tempALen = outLen[j] + toDiscard;
				convSub(tempA,tempALenPrev,tempA,tempD,tempALen,wavelet->lo_a,wavelet->hi_a,wavelet->filtLen,skip);
				memcpy(out[j],tempD+toDiscard,outLen[j]*sizeof(float));
				tempALenPrev = tempALen;
			}
			if(outLen[J] == 0) return;
			convSub(tempA,tempALen,out[J],out[J-1],outLen[J],wavelet->lo_a,wavelet->hi_a,wavelet->filtLen,skip);
		}

		// save in as prev
		// int diff = max(0,prevLen - inLen);
		if( prevLen< inLen)
		 memcpy(prev,in+inLen-maxLeftExt,maxLeftExt*sizeof(float));
		else{
		 memmove(prev,prev+inLen,(prevLen-inLen)*sizeof(float));
		 memcpy(prev+prevLen-inLen,in,inLen*sizeof(float));
		}


	}

	
	void FloatSegDWT::inverseOLA(float* in[], int inLen[],
								float* out, int outLen,
								unsigned long Sn){
		memset(out,0,outLen*sizeof(float));
		int skip = 0;
		int tempIntSkip = 0;
		int tempIntSkip2 = 0;
		 
			int leftExt = leftExtNoRight(Sn,wavelet->filtLen,J);
		if(Sn==0){	
			tempIntSkip2 = maxLeftExt;
			tempIntSkip = minLeftExt;
		}else{
			//tempIntSkip = Sn>=leftExt?0: leftExt-Sn;
		}
		
		

		//int rJ= pow2(J)-1)*(wavelet->filtLen-1);
		if(tempInLenMax < outLen + maxLeftExt + wavelet->filtLen-1){
			if(tempIn) free(tempIn);
			tempInLenMax = outLen + maxLeftExt + wavelet->filtLen-1;
			tempIn = (float*) malloc(tempInLenMax*sizeof(float));
		} 
		memset(tempIn,0,tempInLenMax*sizeof(float));
		tempInLen = outLen + maxLeftExt;

		if(J==1){
			upConv(in[1],in[0],inLen[1],tempIn,tempInLen,wavelet->lo_r,wavelet->hi_r,wavelet->filtLen,skip);
			memcpy(out+maxLeftExt-leftExt,tempIn+tempIntSkip,max(0,(outLen-(maxLeftExt-leftExt)))*sizeof(float));
		}else{
			
			if(tempALenMax < (outLen + maxLeftExt + wavelet->filtLen-1)/2){
				if(tempA) free(tempA);
				tempALenMax = (outLen + maxLeftExt + wavelet->filtLen-1)/2;
				tempA = (float*) malloc(tempALenMax*sizeof(float));
			} 
			memset(tempA,0,tempALenMax*sizeof(float));

			float* helperPtr1 = modPow2(J,2)?tempIn:tempA;
			float* helperPtr2 = modPow2(J,2)?tempA:tempIn;

			int toAdd = appendLeftExtNoRight(Sn,wavelet->filtLen,J,J-1);
			upConv(in[J],in[J-1],inLen[J],helperPtr1,inLen[J-2]+toAdd,wavelet->lo_r,wavelet->hi_r,wavelet->filtLen,skip);

			int toAdd2;
			for(int j=J-1;j>1;j--){
			 toAdd2 = appendLeftExtNoRight(Sn,wavelet->filtLen,J,j-1);
			 toAdd = appendLeftExtNoRight(Sn,wavelet->filtLen,J,j);
			 upConv(helperPtr1,in[j-1]-toAdd,inLen[j-1]+toAdd,helperPtr2,inLen[j-2]+toAdd2,wavelet->lo_r,wavelet->hi_r,wavelet->filtLen,skip);
			 float* change = helperPtr1;
			 helperPtr1 = helperPtr2;
			 helperPtr2 = change;
			} 

			toAdd = appendLeftExtNoRight(Sn,wavelet->filtLen,J,1);
			upConv(helperPtr1,in[0]-toAdd,inLen[0]+toAdd,tempIn,tempInLen,wavelet->lo_r,wavelet->hi_r,wavelet->filtLen,skip);
		}

		memset(tempIn,0,tempIntSkip*sizeof(float));
		// "good" case
		if(overlapLen<=outLen){
			
			memcpy(out+maxLeftExt-leftExt,tempIn+tempIntSkip,max(0,(outLen-(maxLeftExt-leftExt)))*sizeof(float));
			for(int i=0;i<min(overlapLen,outLen);i++) out[i]+=overlap[i];
			
			if(Sn==0) leftExt=minLeftExt;
			memcpy(overlap,tempIn+outLen-(maxLeftExt-leftExt),overlapLen*sizeof(float));
		}
		else{
			if(Sn==0) leftExt=minLeftExt;
			for(int i=0;i<overlapLen-(maxLeftExt-leftExt);i++) overlap[i+maxLeftExt-leftExt]+=tempIn[i];
			memcpy(out,overlap,outLen*sizeof(float));
			//possibly copy to output
			memmove(overlap,overlap+outLen,(overlapLen-outLen)*sizeof(float));
			//memset(overlap+overlapLen-outLen,0,outLen*sizeof(float));
			//for(int i=0;i<outLen;i++) overlap[overlapLen-outLen+i]=tempIn[i+leftExt];
			memcpy(overlap+overlapLen-outLen,tempIn+leftExt,outLen*sizeof(float));

		}
	
	}

	// in -- for convinience, when outLen > (inLen+1-skip)/2, array in  is expected to be extended from the left side by filtLen-1 zero samples (or according to chosen type of extension)
	// (inLen+1-skip)/2 -- number of coefficients one can compute from signal without revebration
	void FloatSegDWT::convSub(float* in, int inLen,
							 float* outLo, float* outHi, int outLen,
							 float* filtLo, float* filtHi, int filtLen,
							 int skip){

		memset(&buffer[0],0,bufferLen*sizeof(float));

		int buffPtr = 0;
		*(buffer + buffPtr++) = *in;
		for(int i = 1;i<=skip;i++){
			*(buffer + buffPtr++) = *(in+i);
		}

	
	

		float tempHi = 0.0f;
        float tempLo = 0.0f;
        float buffTemp = 0.0f;
		for (int i = 0; i < outLen-1; i++) {

            for (int j = 0; j < filtLen; j++) {
                int idx = modPow2((-j+buffPtr-1),bufferLen);
                buffTemp = *(buffer+idx);
                tempHi += buffTemp * filtHi[j];
                tempLo += buffTemp * filtLo[j];
            }
            
            outHi[i] = tempHi;
            outLo[i] = tempLo;
			tempHi = 0.0f; tempLo = 0.0f; buffTemp = 0.0f;


			memcpy(buffer + buffPtr, in + 2*i+1+skip, 2*sizeof(float));
			buffPtr += 2;
			buffPtr = modPow2(buffPtr,bufferLen);
        }
		
		for (int j = 0; j < filtLen; j++) {
                int idx = modPow2((-j+buffPtr-1),bufferLen);
                buffTemp = *(buffer+idx);
                tempHi += buffTemp * filtHi[j];
                tempLo += buffTemp * filtLo[j];
            }
            
            outHi[outLen-1] = tempHi;
            outLo[outLen-1] = tempLo;

		
	}


	void FloatSegDWT::upConv(float* inLo, float* inHi, int inLoLen,
							float* out, int outLen,
							float* filtLo, float* filtHi, int filtLen,
							int skip){
		memset(&buffer[0],0,bufferLen*sizeof(float));
		memset(&buffer2[0],0,bufferLen*sizeof(float));
		int buffPtr = 0;
		int inPtr = 0;
		//int halfFiltLen = 0;

		
		for(int i=0;i<(skip-1)/2;i++){
			buffer[buffPtr] = inLo[inPtr];
			buffer2[buffPtr] = inHi[inPtr];
			buffPtr++;inPtr++;
			buffPtr = modPow2(buffPtr,bufferLen);
		}
		
		float outputTemp = 0.0f;
		int parShift = 0; // variable indicates whether the beginning of the filter is "in between" two upsampled samples
		parShift = (skip)%2;
		for(int i=0;i<outLen;i++){
			// jen kadou druhou iteraci natu dal hodnotu
			
			if(i%2==0 ){
				if(inPtr<inLoLen){
				//printf("%i, ",inPtr);
					buffer[buffPtr] = inLo[inPtr];
					buffer2[buffPtr] = inHi[inPtr];
					inPtr++;
				} else {
					buffer[buffPtr] = 0;
					buffer2[buffPtr] = 0;
				}
				buffPtr++;
				buffPtr = modPow2(buffPtr,bufferLen);
				parShift=0;
			}
		
		
			for(int j = 0;j<(filtLen-parShift+1)/2;j++){
				int idx = modPow2(-j+buffPtr-1,bufferLen);
				outputTemp += buffer[idx]*filtLo[j*2+parShift] + buffer2[idx]*filtHi[j*2+parShift];
			
			}
			out[i] = outputTemp;
			outputTemp = 0.0f;
			parShift=1;
		}
	
		
	}

	void FloatSegDWT::process(float* in, float* out, int inLen, unsigned long Sn){
		forwardOLS(in,inLen,coefOut,coefOutLen,Sn);
		procesor->process(coefOut,coefOutMod,coefOutModLen,J);
		inverseOLA(coefOutMod,coefOutLen,out,inLen,Sn);
	}

	void FloatSegDWT::flush(){
		if(overlap) memset(overlap,0,overlapLen*sizeof(float));
		if(prev) memset(prev,0,prevLen*sizeof(float));
	}

	void FloatSegDWT::initialize(int newJ){
		J = newJ;
		Sn=0;
		bufferLen = nextPow2(wavelet->filtLen);
		buffer = (float*) calloc(bufferLen,sizeof(float));
		buffer2 = (float*) calloc(bufferLen,sizeof(float));
		subbandsToFree = (float**) calloc((J+1),sizeof(float*));
		tempA = 0;
		tempALen = 0;
		tempD = 0;
		tempDLen = 0;
		tempIn = 0;
		tempInLen = 0;
		tempInLenMax = 0;
		maxLeftExt = maxLeftExtNoRight(wavelet->filtLen,J);
		minLeftExt = minLeftExtNoRight(wavelet->filtLen,J);
		tempALenMax = 0;
		tempDLenMax = 0;
		overlapLen = (pow2(J)-1)*(wavelet->filtLen-1);
		prevLen = overlapLen;
		overlap = (float*) calloc(overlapLen, sizeof(float));
		prev = (float*) calloc(overlapLen, sizeof(float));
		procesor = new DefaultProcessor();
		externalProcessor = false;

		coefOut = (float**) calloc((J+1),sizeof(float*));
		coefOutMod = (float**) calloc((J+1),sizeof(float*));
		coefOutLen = (int*) calloc((J+1),sizeof(int));
		coefOutModLen = (int*) calloc((J+1),sizeof(int));
	}


	void FloatSegDWT::allocateSubbands(float** out,int* outLengths,unsigned long Sn,int s,int J){
	int addBeginning = 0;

		for(int j=0;j<J;j++){
			addBeginning = addMaxLeftZerosInv(J,j+1,wavelet->filtLen);
			outLengths[j] = ncoefs(Sn,s,j+1);
			subbandsToFree[j] = (float*) malloc((addBeginning+outLengths[j]+1)*sizeof(float));
			memset(subbandsToFree[j],0,addBeginning*sizeof(float));
			out[j] = subbandsToFree[j] + addBeginning;
			memset(out[j]+outLengths[j],0,sizeof(float));
		}
		outLengths[J] = ncoefs(Sn,s,J);
		subbandsToFree[J] = (float*) malloc((outLengths[J]+1)*sizeof(float));
		out[J] = subbandsToFree[J];
		memset(out[J]+outLengths[J],0,sizeof(float));
	}
	
	void FloatSegDWT::reAllocateOutSubbands(float** out,int* outLengths,unsigned long Sn,int s,int J){
		int tempLen = 0;
		int addBeginning = 0;

		for(int j=0;j<J;j++){
			tempLen = ncoefs(Sn,s,j+1);
			if(tempLen > outLengths[j]){
			  if(subbandsToFree[j]!=0) free(subbandsToFree[j]);
			  addBeginning = addMaxLeftZerosInv(J,j+1,wavelet->filtLen);
			  outLengths[j] = (addBeginning+tempLen+1);
			  subbandsToFree[j] = (float*) malloc(outLengths[j]*sizeof(float));
			  memset(subbandsToFree[j],0,addBeginning*sizeof(float));	
			  out[j] =subbandsToFree[j] + addBeginning;
			}
			memset(out[j]+tempLen,0,max((outLengths[j]-tempLen-addBeginning),0)*sizeof(float));
			outLengths[j]=tempLen;
		}
		tempLen = ncoefs(Sn,s,J);
		if(tempLen > outLengths[J]){
			 if(subbandsToFree[J]!=0) free(subbandsToFree[J]);
			  outLengths[J] = (tempLen+1);
			  subbandsToFree[J] = (float*) malloc(outLengths[J]*sizeof(float));
			  out[J] = subbandsToFree[J]; 
			}
		memset(out[J]+tempLen,0,(outLengths[J]-tempLen)*sizeof(float));
		outLengths[J]=tempLen;
	}

	void FloatSegDWT::reAllocateInSubbands(float** out,int* outLengths,unsigned long Sn,int s,int J){
		int tempLen = 0;
		//int addBeginning = 0;

		for(int j=0;j<J;j++){
			tempLen = ncoefs(Sn,s,j+1);
			if(tempLen > outLengths[j]){
			  if(out[j]!=0) free(out[j]);
			  outLengths[j] = tempLen+1;
			  out[j] = (float*) malloc(outLengths[j]*sizeof(float));
			}
			memset(out[j]+tempLen,0,(outLengths[j]-tempLen)*sizeof(float));
			outLengths[j]=tempLen;

		}
		tempLen = ncoefs(Sn,s,J);
		if(tempLen > outLengths[J]){
			 if(out[J]!=0) free(out[J]);
			  outLengths[J] = (tempLen+1);
			  out[J] = (float*) malloc(outLengths[J]*sizeof(float));
			}
		memset(out[J]+tempLen,0,(outLengths[J]-tempLen)*sizeof(float));
		outLengths[J]=tempLen;
		
	}

	void FloatSegDWT::setJ(int newJ){
		J = newJ;
		if(subbandsToFree) free(subbandsToFree);
		subbandsToFree = (float**) malloc((J+1)*sizeof(float*));
		maxLeftExt = maxLeftExtNoRight(wavelet->filtLen,J);
		if(coefOut) free(coefOut);
		if(coefOutMod) free(coefOutLen);
		if(coefOutLen) free(coefOutMod);
		if(coefOutModLen) free(coefOutModLen);
		if(overlap) free(overlap);
		if(prev) free(prev);

		coefOut = (float**) calloc((J+1),sizeof(float*));
		coefOutMod = (float**) calloc((J+1),sizeof(float*));
		coefOutLen = (int*) calloc((J+1),sizeof(int));
		coefOutModLen = (int*) calloc((J+1),sizeof(int));
		overlapLen = (pow2(J)-1)*(wavelet->filtLen-1);
		prevLen = overlapLen;
		overlap = (float*) calloc(overlapLen, sizeof(float));
		prev = (float*) calloc(overlapLen, sizeof(float));
	}

	void FloatSegDWT::setWavelet(FloatWfilter* newWavelet){
		wavelet = newWavelet;
		if(buffer) free(buffer);
		if(buffer2) free(buffer2);
		bufferLen = nextPow2(wavelet->filtLen);
		buffer = (float*) calloc(bufferLen,sizeof(float));
		buffer2 = (float*) calloc(bufferLen,sizeof(float));
		maxLeftExt = maxLeftExtNoRight(wavelet->filtLen,J);
	}

	FloatSegDWT::~FloatSegDWT(){
		for(int j=0;j<=J;j++){if(subbandsToFree[j]!=0 ) free(subbandsToFree[j]); }
		if(subbandsToFree) free(subbandsToFree);
		if(buffer) free(buffer);
		if(tempA) free(tempA);
		if(tempD) free(tempD);
		if(tempIn) free(tempIn);
		if(buffer2) free(buffer2);
		if(overlap) free(overlap);
		if(prev) free(prev);
		if(procesor && !externalProcessor) delete(procesor);

		if(coefOut) free(coefOut);
		if(coefOutMod) free(coefOutLen);
		if(coefOutLen) free(coefOutMod);
		if(coefOutModLen) free(coefOutModLen);
		if(wavelet) 			delete(wavelet);
	}

	FloatSegDWT::FloatSegDWT(FloatWfilter::Type waveletType,int newJ){
		wavelet = new FloatWfilter(waveletType);
		initialize( newJ);
	}

	FloatSegDWT::FloatSegDWT(FloatWfilter* newWavelet,int newJ){
		wavelet = new FloatWfilter(*newWavelet); // copy
		initialize(newJ);
	}


	
	void DefaultProcessor::process(float** in, float** out,int* coefLens,int J){
		// j-th level detail coefficients
		float* inSubband;
		float* outSubband;
		int jTemp = 0;
		int coefLen = 0;
		for(int j=1;j<=J;j++){
			// corect indexing
			jTemp = j-1;
			coefLen = coefLens[jTemp];
			inSubband = in[jTemp];
			outSubband = out[jTemp];

			for(int i =0;i<coefLen;i++){
				/*****************PLACE FOR j-th level DETAIL COEFFICIENT PROCESSING**************/
				outSubband[i] = inSubband[i];
				//outSubband[i] = 0;
				/*****************END*************************************************************/
			}
		}

	
			jTemp = J;
			coefLen = coefLens[J];
			inSubband = in[J];
			outSubband = out[J];
			for(int i =0;i<coefLen;i++){
				/*****************PLACE FOR APPROX. COEFFICIENT PROCESSING**************/
				outSubband[i] = inSubband[i];
				//outSubband[i] = 0;
				/*****************END*************************************************************/
			}

	}

	void FilterProcessor::process(float** in, float** out,int* coefLens,int J){
		// j-th level detail coefficients
		float* inSubband;
		float* outSubband;
		int jTemp = 0;
		int coefLen = 0;
		for(int j=1;j<=J;j++){
			// corect indexing
			jTemp = j-1;
			coefLen = coefLens[jTemp];
			inSubband = in[jTemp];
			outSubband = out[jTemp];

			for(int i =0;i<coefLen;i++){
				/*****************PLACE FOR j-th level DETAIL COEFFICIENT PROCESSING**************/
				outSubband[i] = inSubband[i]*filterArray[jTemp];
				/*****************END*************************************************************/
			}
		}

	
			jTemp = J;
			coefLen = coefLens[J];
			inSubband = in[J];
			outSubband = out[J];
			for(int i =0;i<coefLen;i++){
				/*****************PLACE FOR APPROX. COEFFICIENT PROCESSING**************/
				outSubband[i] = inSubband[i]*filterArray[J];
				/*****************END*************************************************************/
			}

	}

	void ThresholdProcessor::process(float** in, float** out,int* coefLens,int J){
		// j-th level detail coefficients
		float* inSubband;
		float* outSubband;
		int jTemp = 0;
		int coefLen = 0;
		for(int j=1;j<=J;j++){
			// corect indexing
			jTemp = j-1;
			coefLen = coefLens[jTemp];
			inSubband = in[jTemp];
			outSubband = out[jTemp];

			for(int i =0;i<coefLen;i++){
				/*****************PLACE FOR j-th level DETAIL COEFFICIENT PROCESSING**************/
				hardThreshold(inSubband,outSubband,coefLen,thresholdArray[jTemp]);
				/*****************END*************************************************************/
			}
		}

	
			jTemp = J;
			coefLen = coefLens[J];
			inSubband = in[J];
			outSubband = out[J];
			for(int i =0;i<coefLen;i++){
				/*****************PLACE FOR APPROX. COEFFICIENT PROCESSING**************/
				hardThreshold(inSubband,outSubband,coefLen,thresholdArray[J]);
				/*****************END*************************************************************/
			}

	}

		void ThresholdProcessor::hardThreshold(float* in,float* out,int Len,float threshold){
			for(int i =0;i<Len;i++){
				out[i]= fabs(in[i])>threshold?in[i]:0;
			}
		}



	void RandomProcessor::process(float** in, float** out,int* coefLens,int J){
		// j-th level detail coefficients
		float* inSubband;
		float* outSubband;
		int coefLen = 0;
		int jTemp = 0;


			for(int j=1;j<=J+1;j++){
				jTemp = j-1;
				coefLen = coefLens[jTemp];
				inSubband = in[jTemp];
				outSubband = out[jTemp];
				
				for(int i =0;i<coefLen;i++){	
					int randj = rand()%1000;
					float randMult = ((((float)randj)-500.0f)/500.0f)*fabs(multArray[jTemp]) + 1.0f;
					outSubband[i] = inSubband[i]*randMult;
				}

			}

			

	}



const char* FloatWfilter::typeNames[] = {"haar", "db1", "db2", "db3", "db4", "db5", "db6", "db7", "db8", "db9", "db10", "sym2", "sym3", "sym4",
        "sym5", "sym6", "sym7", "sym8", "coif1", "coif2", "coif3", "coif4", "coif5", "bior11", "bior13",
        "bior15", "bior22", "bior24", "bior26", "bior28", "bior31", "bior33", "bior35", "bior37", "bior39",
        "bior44", "bior55", "bior68", "cust", "NOT_VALID"};

FloatWfilter::FloatWfilter():lo_a(0),hi_a(0),lo_r(0),hi_r(0),filtLen(0){
			this->name = haar;
			initialize(this->name);
		}

FloatWfilter::FloatWfilter(Type name):lo_a(0),hi_a(0),lo_r(0),hi_r(0),filtLen(0),name(name){
			initialize(name);
		}

FloatWfilter::FloatWfilter(const FloatWfilter& old){
		this->filtLen = old.filtLen;
		this->name = old.name;
		this->lo_a = (float*) malloc(this->filtLen*sizeof(float));
		memcpy(this->lo_a,old.lo_a,this->filtLen*sizeof(float));
		this->hi_a = (float*) malloc(this->filtLen*sizeof(float));
		memcpy(this->hi_a,old.hi_a,this->filtLen*sizeof(float));
		this->lo_r = (float*) malloc(this->filtLen*sizeof(float));
		memcpy(this->lo_r,old.lo_r,this->filtLen*sizeof(float));
		this->hi_r = (float*) malloc(this->filtLen*sizeof(float));
		memcpy(this->hi_r,old.hi_r,this->filtLen*sizeof(float));
	}

const FloatWfilter& FloatWfilter::operator=(const FloatWfilter& rhs){
		if(this != &rhs){
			this->filtLen = rhs.filtLen;
			this->name = rhs.name;
			free(this->lo_a); this->lo_a = (float*) malloc(this->filtLen*sizeof(float));
			memcpy(this->lo_a,rhs.lo_a,this->filtLen*sizeof(float));
			free(this->hi_a); this->hi_a = (float*) malloc(this->filtLen*sizeof(float));
			memcpy(this->hi_a,rhs.hi_a,this->filtLen*sizeof(float));
			free(this->lo_r); this->lo_r = (float*) malloc(this->filtLen*sizeof(float));
			memcpy(this->lo_r,rhs.lo_r,this->filtLen*sizeof(float));
			free(this->hi_r); this->hi_r = (float*) malloc(this->filtLen*sizeof(float));
			memcpy(this->hi_r,rhs.hi_r,this->filtLen*sizeof(float));
		}
		return *this;
	}

		FloatWfilter::FloatWfilter(float* lo_a, float* hi_a, float* lo_r,float* hi_r,int filtLen):lo_a(0),hi_a(0),lo_r(0),hi_r(0),filtLen(filtLen),name(cust){
		 this->lo_a = (float*) calloc(filtLen,sizeof(float));
		 this->hi_a = (float*) calloc(filtLen,sizeof(float));
		 this->lo_r = (float*) calloc(filtLen,sizeof(float));
		 this->hi_r = (float*) calloc(filtLen,sizeof(float));
		 memcpy(this->lo_a,lo_a,filtLen*sizeof(float));
		 memcpy(this->hi_a,hi_a,filtLen*sizeof(float));
		 memcpy(this->lo_r,lo_r,filtLen*sizeof(float));
		 memcpy(this->hi_r,hi_r,filtLen*sizeof(float));
		}

	FloatWfilter::~FloatWfilter(){
		if(lo_a) free(lo_a);
		if(hi_a) free(hi_a);
		if(lo_r) free(lo_r);
		if(hi_r) free(hi_r);
	}


float* FloatWfilter::toArray(int n_args, ...){
		va_list ap;
			va_start(ap, n_args);
			float* out = (float*) malloc(n_args*sizeof(float));
			

			for(int i = 0;i<n_args;i++){
			 out[i]=(float) va_arg(ap, double);
			}

		va_end(ap);
		return out;
}

void FloatWfilter::initialize(Type name){
switch (name) {
            case haar:
            case db1:
            case bior11:
				filtLen = 2;
                lo_a = toArray(filtLen,0.7071067812f, 0.7071067812f);
                hi_a = toArray(filtLen,-0.7071067812f, 0.7071067812f);
                lo_r = toArray(filtLen,0.7071067812f, 0.7071067812f);
                hi_r = toArray(filtLen,0.7071067812f, -0.7071067812f);
                break;
            case db2:
				filtLen = 4;
                lo_a = toArray(filtLen,-0.1294095226f, 0.224143868f, 0.8365163037f, 0.4829629131f);
                hi_a = toArray(filtLen,-0.4829629131f, 0.8365163037f, -0.224143868f, -0.1294095226f);
                lo_r = toArray(filtLen,0.4829629131f, 0.8365163037f, 0.224143868f, -0.1294095226f);
                hi_r = toArray(filtLen,-0.1294095226f, -0.224143868f, 0.8365163037f, -0.4829629131f);
                break;
            case db3:
				filtLen = 6;
                lo_a = toArray(filtLen,0.03522629188f, -0.08544127388f, -0.13501102f, 0.4598775021f, 0.8068915093f, 0.332670553f);
                hi_a = toArray(filtLen,-0.332670553f, 0.8068915093f, -0.4598775021f, -0.13501102f, 0.08544127388f, 0.03522629188f);
                lo_r = toArray(filtLen,0.332670553f, 0.8068915093f, 0.4598775021f, -0.13501102f, -0.08544127388f, 0.03522629188f);
                hi_r = toArray(filtLen,0.03522629188f, 0.08544127388f, -0.13501102f, -0.4598775021f, 0.8068915093f, -0.332670553f);
                break;
            case db4:
				filtLen = 8;
                lo_a = toArray(filtLen,-0.01059740178f, 0.03288301167f, 0.03084138184f, -0.1870348117f, -0.02798376942f, 0.6308807679f, 0.7148465706f, 0.2303778133f);
                hi_a = toArray(filtLen,-0.2303778133f, 0.7148465706f, -0.6308807679f, -0.02798376942f, 0.1870348117f, 0.03084138184f, -0.03288301167f, -0.01059740178f);
                lo_r = toArray(filtLen,0.2303778133f, 0.7148465706f, 0.6308807679f, -0.02798376942f, -0.1870348117f, 0.03084138184f, 0.03288301167f, -0.01059740178f);
                hi_r = toArray(filtLen,-0.01059740178f, -0.03288301167f, 0.03084138184f, 0.1870348117f, -0.02798376942f, -0.6308807679f, 0.7148465706f, -0.2303778133f);
                break;
            case db5:
				filtLen = 10;
                lo_a = toArray(filtLen,
                        0.003335725285f,
                        -0.012580752f,
                        -0.006241490213f,
                        0.07757149384f,
                        -0.03224486959f,
                        -0.2422948871f,
                        0.1384281459f,
                        0.7243085284f,
                        0.6038292698f,
                        0.160102398f);
                hi_a = toArray(filtLen,
                        -0.160102398f,
                        0.6038292698f,
                        -0.7243085284f,
                        0.1384281459f,
                        0.2422948871f,
                        -0.03224486959f,
                        -0.07757149384f,
                        -0.006241490213f,
                        0.012580752f,
                        0.003335725285f);
                lo_r = toArray(filtLen,
                        0.160102398f,
                        0.6038292698f,
                        0.7243085284f,
                        0.1384281459f,
                        -0.2422948871f,
                        -0.03224486959f,
                        0.07757149384f,
                        -0.006241490213f,
                        -0.012580752f,
                        0.003335725285f);
                hi_r = toArray(filtLen,
                        0.003335725285f,
                        0.012580752f,
                        -0.006241490213f,
                        -0.07757149384f,
                        -0.03224486959f,
                        0.2422948871f,
                        0.1384281459f,
                        -0.7243085284f,
                        0.6038292698f,
                        -0.160102398f);
                break;

            case db6:
				filtLen = 12;
                lo_a = toArray(filtLen,
                        -0.001077301085f,
                        0.004777257511f,
                        0.000553842201f,
                        -0.03158203932f,
                        0.02752286553f,
                        0.09750160559f,
                        -0.1297668676f,
                        -0.226264694f,
                        0.3152503517f,
                        0.751133908f,
                        0.4946238904f,
                        0.1115407434f);
                hi_a = toArray(filtLen,
                        -0.1115407434f,
                        0.4946238904f,
                        -0.751133908f,
                        0.3152503517f,
                        0.226264694f,
                        -0.1297668676f,
                        -0.09750160559f,
                        0.02752286553f,
                        0.03158203932f,
                        0.000553842201f,
                        -0.004777257511f,
                        -0.001077301085f);
                lo_r = toArray(filtLen,
                        0.1115407434f,
                        0.4946238904f,
                        0.751133908f,
                        0.3152503517f,
                        -0.226264694f,
                        -0.1297668676f,
                        0.09750160559f,
                        0.02752286553f,
                        -0.03158203932f,
                        0.000553842201f,
                        0.004777257511f,
                        -0.001077301085f);
                hi_r = toArray(filtLen,
                        -0.001077301085f,
                        -0.004777257511f,
                        0.000553842201f,
                        0.03158203932f,
                        0.02752286553f,
                        -0.09750160559f,
                        -0.1297668676f,
                        0.226264694f,
                        0.3152503517f,
                        -0.751133908f,
                        0.4946238904f,
                        -0.1115407434f);
                break;

            case db7:
				filtLen = 14;
                lo_a = toArray(filtLen,
                        0.0003537138f,
                        -0.001801640704f,
                        0.000429577973f,
                        0.01255099856f,
                        -0.01657454163f,
                        -0.03802993694f,
                        0.08061260915f,
                        0.07130921927f,
                        -0.224036185f,
                        -0.1439060039f,
                        0.4697822874f,
                        0.7291320908f,
                        0.3965393195f,
                        0.07785205409f);
                hi_a = toArray(filtLen,
                        -0.07785205409f,
                        0.3965393195f,
                        -0.7291320908f,
                        0.4697822874f,
                        0.1439060039f,
                        -0.224036185f,
                        -0.07130921927f,
                        0.08061260915f,
                        0.03802993694f,
                        -0.01657454163f,
                        -0.01255099856f,
                        0.000429577973f,
                        0.001801640704f,
                        0.0003537138f);
                lo_r = toArray(filtLen,
                        0.07785205409f,
                        0.3965393195f,
                        0.7291320908f,
                        0.4697822874f,
                        -0.1439060039f,
                        -0.224036185f,
                        0.07130921927f,
                        0.08061260915f,
                        -0.03802993694f,
                        -0.01657454163f,
                        0.01255099856f,
                        0.000429577973f,
                        -0.001801640704f,
                        0.0003537138f);
                hi_r = toArray(filtLen,
                        0.0003537138f,
                        0.001801640704f,
                        0.000429577973f,
                        -0.01255099856f,
                        -0.01657454163f,
                        0.03802993694f,
                        0.08061260915f,
                        -0.07130921927f,
                        -0.224036185f,
                        0.1439060039f,
                        0.4697822874f,
                        -0.7291320908f,
                        0.3965393195f,
                        -0.07785205409f);
                break;

            case db8:
				filtLen = 16;
                lo_a = toArray(filtLen,
                        -0.000117476784f,
                        0.000675449406f,
                        -0.000391740373f,
                        -0.004870352993f,
                        0.008746094047f,
                        0.01398102792f,
                        -0.04408825393f,
                        -0.017369301f,
                        0.1287474266f,
                        0.000472484574f,
                        -0.284015543f,
                        -0.01582910526f,
                        0.5853546837f,
                        0.6756307363f,
                        0.3128715909f,
                        0.05441584224f);
                hi_a = toArray(filtLen,
                        -0.05441584224f,
                        0.3128715909f,
                        -0.6756307363f,
                        0.5853546837f,
                        0.01582910526f,
                        -0.284015543f,
                        -0.000472484574f,
                        0.1287474266f,
                        0.017369301f,
                        -0.04408825393f,
                        -0.01398102792f,
                        0.008746094047f,
                        0.004870352993f,
                        -0.000391740373f,
                        -0.000675449406f,
                        -0.000117476784f);
                lo_r = toArray(filtLen,
                        0.05441584224f,
                        0.3128715909f,
                        0.6756307363f,
                        0.5853546837f,
                        -0.01582910526f,
                        -0.284015543f,
                        0.000472484574f,
                        0.1287474266f,
                        -0.017369301f,
                        -0.04408825393f,
                        0.01398102792f,
                        0.008746094047f,
                        -0.004870352993f,
                        -0.000391740373f,
                        0.000675449406f,
                        -0.000117476784f);
                hi_r = toArray(filtLen,
                        -0.000117476784f,
                        -0.000675449406f,
                        -0.000391740373f,
                        0.004870352993f,
                        0.008746094047f,
                        -0.01398102792f,
                        -0.04408825393f,
                        0.017369301f,
                        0.1287474266f,
                        -0.000472484574f,
                        -0.284015543f,
                        0.01582910526f,
                        0.5853546837f,
                        -0.6756307363f,
                        0.3128715909f,
                        -0.05441584224f);
                break;

            case db9:
				filtLen = 18;
                lo_a = toArray(filtLen,
                        3.934732e-005f,
                        -0.000251963189f,
                        0.000230385764f,
                        0.001847646883f,
                        -0.004281503682f,
                        -0.004723204758f,
                        0.02236166212f,
                        0.000250947115f,
                        -0.06763282906f,
                        0.03072568148f,
                        0.1485407493f,
                        -0.09684078322f,
                        -0.2932737833f,
                        0.1331973858f,
                        0.657288078f,
                        0.6048231237f,
                        0.2438346746f,
                        0.03807794736f);
                hi_a = toArray(filtLen,
                        -0.03807794736f,
                        0.2438346746f,
                        -0.6048231237f,
                        0.657288078f,
                        -0.1331973858f,
                        -0.2932737833f,
                        0.09684078322f,
                        0.1485407493f,
                        -0.03072568148f,
                        -0.06763282906f,
                        -0.000250947115f,
                        0.02236166212f,
                        0.004723204758f,
                        -0.004281503682f,
                        -0.001847646883f,
                        0.000230385764f,
                        0.000251963189f,
                        3.934732e-005f);
                lo_r = toArray(filtLen,
                        0.03807794736f,
                        0.2438346746f,
                        0.6048231237f,
                        0.657288078f,
                        0.1331973858f,
                        -0.2932737833f,
                        -0.09684078322f,
                        0.1485407493f,
                        0.03072568148f,
                        -0.06763282906f,
                        0.000250947115f,
                        0.02236166212f,
                        -0.004723204758f,
                        -0.004281503682f,
                        0.001847646883f,
                        0.000230385764f,
                        -0.000251963189f,
                        3.934732e-005f);
                hi_r = toArray(filtLen,
                        3.934732e-005f,
                        0.000251963189f,
                        0.000230385764f,
                        -0.001847646883f,
                        -0.004281503682f,
                        0.004723204758f,
                        0.02236166212f,
                        -0.000250947115f,
                        -0.06763282906f,
                        -0.03072568148f,
                        0.1485407493f,
                        0.09684078322f,
                        -0.2932737833f,
                        -0.1331973858f,
                        0.657288078f,
                        -0.6048231237f,
                        0.2438346746f,
                        -0.03807794736f);
                break;

            case db10:
				filtLen = 20;
                lo_a = toArray(filtLen,
                        -1.3264203e-005f,
                        9.358867e-005f,
                        -0.000116466855f,
                        -0.000685856695f,
                        0.001992405295f,
                        0.001395351747f,
                        -0.01073317548f,
                        0.003606553567f,
                        0.03321267406f,
                        -0.02945753682f,
                        -0.07139414717f,
                        0.0930573646f,
                        0.1273693403f,
                        -0.1959462744f,
                        -0.2498464243f,
                        0.2811723437f,
                        0.6884590395f,
                        0.5272011889f,
                        0.1881768001f,
                        0.0266700579f);
                hi_a = toArray(filtLen,
                        -0.0266700579f,
                        0.1881768001f,
                        -0.5272011889f,
                        0.6884590395f,
                        -0.2811723437f,
                        -0.2498464243f,
                        0.1959462744f,
                        0.1273693403f,
                        -0.0930573646f,
                        -0.07139414717f,
                        0.02945753682f,
                        0.03321267406f,
                        -0.003606553567f,
                        -0.01073317548f,
                        -0.001395351747f,
                        0.001992405295f,
                        0.000685856695f,
                        -0.000116466855f,
                        -9.358867e-005f,
                        -1.3264203e-005f);
                lo_r = toArray(filtLen,
                        0.0266700579f,
                        0.1881768001f,
                        0.5272011889f,
                        0.6884590395f,
                        0.2811723437f,
                        -0.2498464243f,
                        -0.1959462744f,
                        0.1273693403f,
                        0.0930573646f,
                        -0.07139414717f,
                        -0.02945753682f,
                        0.03321267406f,
                        0.003606553567f,
                        -0.01073317548f,
                        0.001395351747f,
                        0.001992405295f,
                        -0.000685856695f,
                        -0.000116466855f,
                        9.358867e-005f,
                        -1.3264203e-005f);
                hi_r = toArray(filtLen,
                        -1.3264203e-005f,
                        -9.358867e-005f,
                        -0.000116466855f,
                        0.000685856695f,
                        0.001992405295f,
                        -0.001395351747f,
                        -0.01073317548f,
                        -0.003606553567f,
                        0.03321267406f,
                        0.02945753682f,
                        -0.07139414717f,
                        -0.0930573646f,
                        0.1273693403f,
                        0.1959462744f,
                        -0.2498464243f,
                        -0.2811723437f,
                        0.6884590395f,
                        -0.5272011889f,
                        0.1881768001f,
                        -0.0266700579f);
                break;

            case sym2:
				filtLen = 4;
                lo_a = toArray(filtLen,
                        -0.1294095226f,
                        0.224143868f,
                        0.8365163037f,
                        0.4829629131f);
                hi_a = toArray(filtLen,
                        -0.4829629131f,
                        0.8365163037f,
                        -0.224143868f,
                        -0.1294095226f);
                lo_r = toArray(filtLen,
                        0.4829629131f,
                        0.8365163037f,
                        0.224143868f,
                        -0.1294095226f);
                hi_r = toArray(filtLen,
                        -0.1294095226f,
                        -0.224143868f,
                        0.8365163037f,
                        -0.4829629131f);
                break;

            case sym3:
				filtLen = 6;
                lo_a = toArray(filtLen,
                        0.03522629188f,
                        -0.08544127388f,
                        -0.13501102f,
                        0.4598775021f,
                        0.8068915093f,
                        0.332670553f);
                hi_a = toArray(filtLen,
                        -0.332670553f,
                        0.8068915093f,
                        -0.4598775021f,
                        -0.13501102f,
                        0.08544127388f,
                        0.03522629188f);
                lo_r = toArray(filtLen,
                        0.332670553f,
                        0.8068915093f,
                        0.4598775021f,
                        -0.13501102f,
                        -0.08544127388f,
                        0.03522629188f);
                hi_r = toArray(filtLen,
                        0.03522629188f,
                        0.08544127388f,
                        -0.13501102f,
                        -0.4598775021f,
                        0.8068915093f,
                        -0.332670553f);
                break;

            case sym4:
				filtLen = 8;
                lo_a = toArray(filtLen,
                        -0.07576571479f,
                        -0.02963552765f,
                        0.4976186676f,
                        0.8037387518f,
                        0.2978577956f,
                        -0.09921954358f,
                        -0.01260396726f,
                        0.0322231006f);
                hi_a = toArray(filtLen,
                        -0.0322231006f,
                        -0.01260396726f,
                        0.09921954358f,
                        0.2978577956f,
                        -0.8037387518f,
                        0.4976186676f,
                        0.02963552765f,
                        -0.07576571479f);
                lo_r = toArray(filtLen,
                        0.0322231006f,
                        -0.01260396726f,
                        -0.09921954358f,
                        0.2978577956f,
                        0.8037387518f,
                        0.4976186676f,
                        -0.02963552765f,
                        -0.07576571479f);
                hi_r = toArray(filtLen,
                        -0.07576571479f,
                        0.02963552765f,
                        0.4976186676f,
                        -0.8037387518f,
                        0.2978577956f,
                        0.09921954358f,
                        -0.01260396726f,
                        -0.0322231006f);
                break;

            case sym5:
				filtLen = 10;
                lo_a = toArray(filtLen,
                        0.02733306835f,
                        0.02951949093f,
                        -0.0391342493f,
                        0.199397534f,
                        0.7234076904f,
                        0.6339789635f,
                        0.01660210576f,
                        -0.1753280899f,
                        -0.02110183402f,
                        0.01953888274f);
                hi_a = toArray(filtLen,
                        -0.01953888274f,
                        -0.02110183402f,
                        0.1753280899f,
                        0.01660210576f,
                        -0.6339789635f,
                        0.7234076904f,
                        -0.199397534f,
                        -0.0391342493f,
                        -0.02951949093f,
                        0.02733306835f);
                lo_r = toArray(filtLen,
                        0.01953888274f,
                        -0.02110183402f,
                        -0.1753280899f,
                        0.01660210576f,
                        0.6339789635f,
                        0.7234076904f,
                        0.199397534f,
                        -0.0391342493f,
                        0.02951949093f,
                        0.02733306835f);
                hi_r = toArray(filtLen,
                        0.02733306835f,
                        -0.02951949093f,
                        -0.0391342493f,
                        -0.199397534f,
                        0.7234076904f,
                        -0.6339789635f,
                        0.01660210576f,
                        0.1753280899f,
                        -0.02110183402f,
                        -0.01953888274f);
                break;

            case sym6:
				filtLen=12;
                lo_a = toArray(filtLen,
                        0.01540410933f,
                        0.003490712084f,
                        -0.1179901111f,
                        -0.04831174259f,
                        0.4910559419f,
                        0.787641141f,
                        0.3379294217f,
                        -0.07263752279f,
                        -0.02106029251f,
                        0.04472490177f,
                        0.001767711864f,
                        -0.007800708325f);
                hi_a = toArray(filtLen,
                        0.007800708325f,
                        0.001767711864f,
                        -0.04472490177f,
                        -0.02106029251f,
                        0.07263752279f,
                        0.3379294217f,
                        -0.787641141f,
                        0.4910559419f,
                        0.04831174259f,
                        -0.1179901111f,
                        -0.003490712084f,
                        0.01540410933f);
                lo_r = toArray(filtLen,
                        -0.007800708325f,
                        0.001767711864f,
                        0.04472490177f,
                        -0.02106029251f,
                        -0.07263752279f,
                        0.3379294217f,
                        0.787641141f,
                        0.4910559419f,
                        -0.04831174259f,
                        -0.1179901111f,
                        0.003490712084f,
                        0.01540410933f);
                hi_r = toArray(filtLen,
                        0.01540410933f,
                        -0.003490712084f,
                        -0.1179901111f,
                        0.04831174259f,
                        0.4910559419f,
                        -0.787641141f,
                        0.3379294217f,
                        0.07263752279f,
                        -0.02106029251f,
                        -0.04472490177f,
                        0.001767711864f,
                        0.007800708325f);
                break;

            case sym7:
				filtLen = 14;
                lo_a = toArray(filtLen,
                        0.002681814568f,
                        -0.001047384889f,
                        -0.0126363034f,
                        0.03051551317f,
                        0.0678926935f,
                        -0.04955283494f,
                        0.01744125509f,
                        0.5361019171f,
                        0.767764317f,
                        0.2886296318f,
                        -0.1400472404f,
                        -0.1078082377f,
                        0.004010244872f,
                        0.01026817671f);
                hi_a = toArray(filtLen,
                        -0.01026817671f,
                        0.004010244872f,
                        0.1078082377f,
                        -0.1400472404f,
                        -0.2886296318f,
                        0.767764317f,
                        -0.5361019171f,
                        0.01744125509f,
                        0.04955283494f,
                        0.0678926935f,
                        -0.03051551317f,
                        -0.0126363034f,
                        0.001047384889f,
                        0.002681814568f);
                lo_r = toArray(filtLen,
                        0.01026817671f,
                        0.004010244872f,
                        -0.1078082377f,
                        -0.1400472404f,
                        0.2886296318f,
                        0.767764317f,
                        0.5361019171f,
                        0.01744125509f,
                        -0.04955283494f,
                        0.0678926935f,
                        0.03051551317f,
                        -0.0126363034f,
                        -0.001047384889f,
                        0.002681814568f);
                hi_r = toArray(filtLen,
                        0.002681814568f,
                        0.001047384889f,
                        -0.0126363034f,
                        -0.03051551317f,
                        0.0678926935f,
                        0.04955283494f,
                        0.01744125509f,
                        -0.5361019171f,
                        0.767764317f,
                        -0.2886296318f,
                        -0.1400472404f,
                        0.1078082377f,
                        0.004010244872f,
                        -0.01026817671f);
                break;

            case sym8:
				filtLen = 16;
                lo_a = toArray(filtLen,
                        -0.003382415951f,
                        -0.0005421323318f,
                        0.03169508781f,
                        0.007607487325f,
                        -0.1432942384f,
                        -0.06127335907f,
                        0.4813596513f,
                        0.7771857517f,
                        0.3644418948f,
                        -0.05194583811f,
                        -0.02721902992f,
                        0.04913717967f,
                        0.003808752014f,
                        -0.01495225834f,
                        -0.0003029205147f,
                        0.001889950333f);
                hi_a = toArray(filtLen,
                        -0.001889950333f,
                        -0.0003029205147f,
                        0.01495225834f,
                        0.003808752014f,
                        -0.04913717967f,
                        -0.02721902992f,
                        0.05194583811f,
                        0.3644418948f,
                        -0.7771857517f,
                        0.4813596513f,
                        0.06127335907f,
                        -0.1432942384f,
                        -0.007607487325f,
                        0.03169508781f,
                        0.0005421323318f,
                        -0.003382415951f);
                lo_r = toArray(filtLen,
                        0.001889950333f,
                        -0.0003029205147f,
                        -0.01495225834f,
                        0.003808752014f,
                        0.04913717967f,
                        -0.02721902992f,
                        -0.05194583811f,
                        0.3644418948f,
                        0.7771857517f,
                        0.4813596513f,
                        -0.06127335907f,
                        -0.1432942384f,
                        0.007607487325f,
                        0.03169508781f,
                        -0.0005421323318f,
                        -0.003382415951f);
                hi_r = toArray(filtLen,
                        -0.003382415951f,
                        0.0005421323318f,
                        0.03169508781f,
                        -0.007607487325f,
                        -0.1432942384f,
                        0.06127335907f,
                        0.4813596513f,
                        -0.7771857517f,
                        0.3644418948f,
                        0.05194583811f,
                        -0.02721902992f,
                        -0.04913717967f,
                        0.003808752014f,
                        0.01495225834f,
                        -0.0003029205147f,
                        -0.001889950333f);
                break;

            case coif1:
				filtLen = 6;
                lo_a = toArray(filtLen,
                        -0.01565572814f,
                        -0.07273261951f,
                        0.3848648469f,
                        0.8525720202f,
                        0.3378976625f,
                        -0.07273261951f);
                hi_a = toArray(filtLen,
                        0.07273261951f,
                        0.3378976625f,
                        -0.8525720202f,
                        0.3848648469f,
                        0.07273261951f,
                        -0.01565572814f);
                lo_r = toArray(filtLen,
                        -0.07273261951f,
                        0.3378976625f,
                        0.8525720202f,
                        0.3848648469f,
                        -0.07273261951f,
                        -0.01565572814f);
                hi_r = toArray(filtLen,
                        -0.01565572814f,
                        0.07273261951f,
                        0.3848648469f,
                        -0.8525720202f,
                        0.3378976625f,
                        0.07273261951f);
                break;

            case coif2:
				filtLen = 12;
                lo_a = toArray(filtLen,
                        -0.0007205494454f,
                        -0.001823208871f,
                        0.005611434819f,
                        0.02368017195f,
                        -0.05943441865f,
                        -0.07648859908f,
                        0.4170051844f,
                        0.8127236354f,
                        0.3861100668f,
                        -0.06737255472f,
                        -0.04146493678f,
                        0.01638733646f);
                hi_a = toArray(filtLen,
                        -0.01638733646f,
                        -0.04146493678f,
                        0.06737255472f,
                        0.3861100668f,
                        -0.8127236354f,
                        0.4170051844f,
                        0.07648859908f,
                        -0.05943441865f,
                        -0.02368017195f,
                        0.005611434819f,
                        0.001823208871f,
                        -0.0007205494454f);
                lo_r = toArray(filtLen,
                        0.01638733646f,
                        -0.04146493678f,
                        -0.06737255472f,
                        0.3861100668f,
                        0.8127236354f,
                        0.4170051844f,
                        -0.07648859908f,
                        -0.05943441865f,
                        0.02368017195f,
                        0.005611434819f,
                        -0.001823208871f,
                        -0.0007205494454f);
                hi_r = toArray(filtLen,
                        -0.0007205494454f,
                        0.001823208871f,
                        0.005611434819f,
                        -0.02368017195f,
                        -0.05943441865f,
                        0.07648859908f,
                        0.4170051844f,
                        -0.8127236354f,
                        0.3861100668f,
                        0.06737255472f,
                        -0.04146493678f,
                        -0.01638733646f);
                break;

            case coif3:
				filtLen= 18;
                lo_a = toArray(filtLen,
                        -3.459977284e-005f,
                        -7.098330314e-005f,
                        0.0004662169601f,
                        0.001117518771f,
                        -0.002574517689f,
                        -0.009007976137f,
                        0.01588054486f,
                        0.03455502757f,
                        -0.08230192711f,
                        -0.07179982162f,
                        0.4284834764f,
                        0.7937772226f,
                        0.4051769024f,
                        -0.06112339f,
                        -0.06577191128f,
                        0.02345269614f,
                        0.007782596427f,
                        -0.003793512864f);
                hi_a = toArray(filtLen,
                        0.003793512864f,
                        0.007782596427f,
                        -0.02345269614f,
                        -0.06577191128f,
                        0.06112339f,
                        0.4051769024f,
                        -0.7937772226f,
                        0.4284834764f,
                        0.07179982162f,
                        -0.08230192711f,
                        -0.03455502757f,
                        0.01588054486f,
                        0.009007976137f,
                        -0.002574517689f,
                        -0.001117518771f,
                        0.0004662169601f,
                        7.098330314e-005f,
                        -3.459977284e-005f);
                lo_r = toArray(filtLen,
                        -0.003793512864f,
                        0.007782596427f,
                        0.02345269614f,
                        -0.06577191128f,
                        -0.06112339f,
                        0.4051769024f,
                        0.7937772226f,
                        0.4284834764f,
                        -0.07179982162f,
                        -0.08230192711f,
                        0.03455502757f,
                        0.01588054486f,
                        -0.009007976137f,
                        -0.002574517689f,
                        0.001117518771f,
                        0.0004662169601f,
                        -7.098330314e-005f,
                        -3.459977284e-005f);
                hi_r = toArray(filtLen,
                        -3.459977284e-005f,
                        7.098330314e-005f,
                        0.0004662169601f,
                        -0.001117518771f,
                        -0.002574517689f,
                        0.009007976137f,
                        0.01588054486f,
                        -0.03455502757f,
                        -0.08230192711f,
                        0.07179982162f,
                        0.4284834764f,
                        -0.7937772226f,
                        0.4051769024f,
                        0.06112339f,
                        -0.06577191128f,
                        -0.02345269614f,
                        0.007782596427f,
                        0.003793512864f);
                break;

            case coif4:
				filtLen = 24;
                lo_a = toArray(filtLen,
                        -1.784985003e-006f,
                        -3.259680237e-006f,
                        3.122987587e-005f,
                        6.233903446e-005f,
                        -0.0002599745525f,
                        -0.0005890207562f,
                        0.001266561929f,
                        0.003751436157f,
                        -0.005658286687f,
                        -0.01521173153f,
                        0.02508226184f,
                        0.03933442712f,
                        -0.09622044203f,
                        -0.06662747426f,
                        0.4343860565f,
                        0.7822389309f,
                        0.415308407f,
                        -0.05607731332f,
                        -0.08126669968f,
                        0.02668230016f,
                        0.01606894396f,
                        -0.007346166328f,
                        -0.001629492013f,
                        0.0008923136686f);
                hi_a = toArray(filtLen,
                        -0.0008923136686f,
                        -0.001629492013f,
                        0.007346166328f,
                        0.01606894396f,
                        -0.02668230016f,
                        -0.08126669968f,
                        0.05607731332f,
                        0.415308407f,
                        -0.7822389309f,
                        0.4343860565f,
                        0.06662747426f,
                        -0.09622044203f,
                        -0.03933442712f,
                        0.02508226184f,
                        0.01521173153f,
                        -0.005658286687f,
                        -0.003751436157f,
                        0.001266561929f,
                        0.0005890207562f,
                        -0.0002599745525f,
                        -6.233903446e-005f,
                        3.122987587e-005f,
                        3.259680237e-006f,
                        -1.784985003e-006f);
                lo_r = toArray(filtLen,
                        0.0008923136686f,
                        -0.001629492013f,
                        -0.007346166328f,
                        0.01606894396f,
                        0.02668230016f,
                        -0.08126669968f,
                        -0.05607731332f,
                        0.415308407f,
                        0.7822389309f,
                        0.4343860565f,
                        -0.06662747426f,
                        -0.09622044203f,
                        0.03933442712f,
                        0.02508226184f,
                        -0.01521173153f,
                        -0.005658286687f,
                        0.003751436157f,
                        0.001266561929f,
                        -0.0005890207562f,
                        -0.0002599745525f,
                        6.233903446e-005f,
                        3.122987587e-005f,
                        -3.259680237e-006f,
                        -1.784985003e-006f);
                hi_r = toArray(filtLen,
                        -1.784985003e-006f,
                        3.259680237e-006f,
                        3.122987587e-005f,
                        -6.233903446e-005f,
                        -0.0002599745525f,
                        0.0005890207562f,
                        0.001266561929f,
                        -0.003751436157f,
                        -0.005658286687f,
                        0.01521173153f,
                        0.02508226184f,
                        -0.03933442712f,
                        -0.09622044203f,
                        0.06662747426f,
                        0.4343860565f,
                        -0.7822389309f,
                        0.415308407f,
                        0.05607731332f,
                        -0.08126669968f,
                        -0.02668230016f,
                        0.01606894396f,
                        0.007346166328f,
                        -0.001629492013f,
                        -0.0008923136686f);
                break;

            case coif5:
				filtLen = 30;
                lo_a = toArray(filtLen,
                        -9.517657274e-008f,
                        -1.674428858e-007f,
                        2.063761851e-006f,
                        3.734655175e-006f,
                        -2.131502681e-005f,
                        -4.134043227e-005f,
                        0.0001405411497f,
                        0.0003022595818f,
                        -0.000638131343f,
                        -0.001662863702f,
                        0.002433373213f,
                        0.006764185448f,
                        -0.009164231162f,
                        -0.01976177894f,
                        0.03268357427f,
                        0.04128920875f,
                        -0.1055742087f,
                        -0.06203596396f,
                        0.4379916262f,
                        0.7742896037f,
                        0.4215662067f,
                        -0.05204316318f,
                        -0.09192001056f,
                        0.02816802897f,
                        0.02340815679f,
                        -0.01013111752f,
                        -0.004159358781f,
                        0.002178236358f,
                        0.0003585896879f,
                        -0.0002120808398f);
                hi_a = toArray(filtLen,
                        0.0002120808398f,
                        0.0003585896879f,
                        -0.002178236358f,
                        -0.004159358781f,
                        0.01013111752f,
                        0.02340815679f,
                        -0.02816802897f,
                        -0.09192001056f,
                        0.05204316318f,
                        0.4215662067f,
                        -0.7742896037f,
                        0.4379916262f,
                        0.06203596396f,
                        -0.1055742087f,
                        -0.04128920875f,
                        0.03268357427f,
                        0.01976177894f,
                        -0.009164231162f,
                        -0.006764185448f,
                        0.002433373213f,
                        0.001662863702f,
                        -0.000638131343f,
                        -0.0003022595818f,
                        0.0001405411497f,
                        4.134043227e-005f,
                        -2.131502681e-005f,
                        -3.734655175e-006f,
                        2.063761851e-006f,
                        1.674428858e-007f,
                        -9.517657274e-008f);
                lo_r = toArray(filtLen,
                        -0.0002120808398f,
                        0.0003585896879f,
                        0.002178236358f,
                        -0.004159358781f,
                        -0.01013111752f,
                        0.02340815679f,
                        0.02816802897f,
                        -0.09192001056f,
                        -0.05204316318f,
                        0.4215662067f,
                        0.7742896037f,
                        0.4379916262f,
                        -0.06203596396f,
                        -0.1055742087f,
                        0.04128920875f,
                        0.03268357427f,
                        -0.01976177894f,
                        -0.009164231162f,
                        0.006764185448f,
                        0.002433373213f,
                        -0.001662863702f,
                        -0.000638131343f,
                        0.0003022595818f,
                        0.0001405411497f,
                        -4.134043227e-005f,
                        -2.131502681e-005f,
                        3.734655175e-006f,
                        2.063761851e-006f,
                        -1.674428858e-007f,
                        -9.517657274e-008f);
                hi_r = toArray(filtLen,
                        -9.517657274e-008f,
                        1.674428858e-007f,
                        2.063761851e-006f,
                        -3.734655175e-006f,
                        -2.131502681e-005f,
                        4.134043227e-005f,
                        0.0001405411497f,
                        -0.0003022595818f,
                        -0.000638131343f,
                        0.001662863702f,
                        0.002433373213f,
                        -0.006764185448f,
                        -0.009164231162f,
                        0.01976177894f,
                        0.03268357427f,
                        -0.04128920875f,
                        -0.1055742087f,
                        0.06203596396f,
                        0.4379916262f,
                        -0.7742896037f,
                        0.4215662067f,
                        0.05204316318f,
                        -0.09192001056f,
                        -0.02816802897f,
                        0.02340815679f,
                        0.01013111752f,
                        -0.004159358781f,
                        -0.002178236358f,
                        0.0003585896879f,
                        0.0002120808398f);
                break;
            case bior13:
				filtLen = 6;
                lo_a = toArray(filtLen,
                        -0.08838834765f,
                        0.08838834765f,
                        0.7071067812f,
                        0.7071067812f,
                        0.08838834765f,
                        -0.08838834765f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.7071067812f,
                        0.7071067812f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.7071067812f,
                        0.7071067812f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        -0.08838834765f,
                        -0.08838834765f,
                        0.7071067812f,
                        -0.7071067812f,
                        0.08838834765f,
                        0.08838834765f);
                break;

            case bior15:
				filtLen = 10;
                lo_a = toArray(filtLen,
                        0.01657281518f,
                        -0.01657281518f,
                        -0.121533978f,
                        0.121533978f,
                        0.7071067812f,
                        0.7071067812f,
                        0.121533978f,
                        -0.121533978f,
                        -0.01657281518f,
                        0.01657281518f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.7071067812f,
                        0.7071067812f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.7071067812f,
                        0.7071067812f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.01657281518f,
                        0.01657281518f,
                        -0.121533978f,
                        -0.121533978f,
                        0.7071067812f,
                        -0.7071067812f,
                        0.121533978f,
                        0.121533978f,
                        -0.01657281518f,
                        -0.01657281518f);
                break;

            case bior22:
				filtLen = 6;
                lo_a = toArray(filtLen,
                        0.0f,
                        -0.1767766953f,
                        0.3535533906f,
                        1.060660172f,
                        0.3535533906f,
                        -0.1767766953f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.3535533906f,
                        -0.7071067812f,
                        0.3535533906f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.3535533906f,
                        0.7071067812f,
                        0.3535533906f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.0f,
                        0.1767766953f,
                        0.3535533906f,
                        -1.060660172f,
                        0.3535533906f,
                        0.1767766953f);
                break;

            case bior24:
				filtLen = 10;
                lo_a = toArray(filtLen,
                        0.0f,
                        0.03314563037f,
                        -0.06629126074f,
                        -0.1767766953f,
                        0.4198446513f,
                        0.994368911f,
                        0.4198446513f,
                        -0.1767766953f,
                        -0.06629126074f,
                        0.03314563037f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.3535533906f,
                        -0.7071067812f,
                        0.3535533906f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.3535533906f,
                        0.7071067812f,
                        0.3535533906f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.0f,
                        -0.03314563037f,
                        -0.06629126074f,
                        0.1767766953f,
                        0.4198446513f,
                        -0.994368911f,
                        0.4198446513f,
                        0.1767766953f,
                        -0.06629126074f,
                        -0.03314563037f);
                break;

            case bior26:
				filtLen = 14;
                lo_a = toArray(filtLen,
                        0.0f,
                        -0.00690533966f,
                        0.01381067932f,
                        0.04695630969f,
                        -0.1077232987f,
                        -0.1698713556f,
                        0.44746601f,
                        0.9667475524f,
                        0.44746601f,
                        -0.1698713556f,
                        -0.1077232987f,
                        0.04695630969f,
                        0.01381067932f,
                        -0.00690533966f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.3535533906f,
                        -0.7071067812f,
                        0.3535533906f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.3535533906f,
                        0.7071067812f,
                        0.3535533906f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.0f,
                        0.00690533966f,
                        0.01381067932f,
                        -0.04695630969f,
                        -0.1077232987f,
                        0.1698713556f,
                        0.44746601f,
                        -0.9667475524f,
                        0.44746601f,
                        0.1698713556f,
                        -0.1077232987f,
                        -0.04695630969f,
                        0.01381067932f,
                        0.00690533966f);
                break;

            case bior28:
				filtLen = 18;
                lo_a = toArray(filtLen,
                        0.0f,
                        0.001510543051f,
                        -0.003021086101f,
                        -0.01294751186f,
                        0.02891610983f,
                        0.05299848189f,
                        -0.1349130736f,
                        -0.1638291834f,
                        0.4625714405f,
                        0.9516421219f,
                        0.4625714405f,
                        -0.1638291834f,
                        -0.1349130736f,
                        0.05299848189f,
                        0.02891610983f,
                        -0.01294751186f,
                        -0.003021086101f,
                        0.001510543051f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.3535533906f,
                        -0.7071067812f,
                        0.3535533906f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.3535533906f,
                        0.7071067812f,
                        0.3535533906f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.0f,
                        -0.001510543051f,
                        -0.003021086101f,
                        0.01294751186f,
                        0.02891610983f,
                        -0.05299848189f,
                        -0.1349130736f,
                        0.1638291834f,
                        0.4625714405f,
                        -0.9516421219f,
                        0.4625714405f,
                        0.1638291834f,
                        -0.1349130736f,
                        -0.05299848189f,
                        0.02891610983f,
                        0.01294751186f,
                        -0.003021086101f,
                        -0.001510543051f);
                break;

            case bior31:
				filtLen = 4;
                lo_a = toArray(filtLen,
                        -0.3535533906f,
                        1.060660172f,
                        1.060660172f,
                        -0.3535533906f);
                hi_a = toArray(filtLen,
                        -0.1767766953f,
                        0.5303300859f,
                        -0.5303300859f,
                        0.1767766953f);
                lo_r = toArray(filtLen,
                        0.1767766953f,
                        0.5303300859f,
                        0.5303300859f,
                        0.1767766953f);
                hi_r = toArray(filtLen,
                        -0.3535533906f,
                        -1.060660172f,
                        1.060660172f,
                        0.3535533906f);
                break;

            case bior33:
				filtLen = 8;
                lo_a = toArray(filtLen,
                        0.06629126074f,
                        -0.1988737822f,
                        -0.1546796084f,
                        0.994368911f,
                        0.994368911f,
                        -0.1546796084f,
                        -0.1988737822f,
                        0.06629126074f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.1767766953f,
                        0.5303300859f,
                        -0.5303300859f,
                        0.1767766953f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.1767766953f,
                        0.5303300859f,
                        0.5303300859f,
                        0.1767766953f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.06629126074f,
                        0.1988737822f,
                        -0.1546796084f,
                        -0.994368911f,
                        0.994368911f,
                        0.1546796084f,
                        -0.1988737822f,
                        -0.06629126074f);
                break;

            case bior35:
				filtLen = 12;
                lo_a = toArray(filtLen,
                        -0.01381067932f,
                        0.04143203796f,
                        0.05248058142f,
                        -0.2679271788f,
                        -0.07181553246f,
                        0.9667475524f,
                        0.9667475524f,
                        -0.07181553246f,
                        -0.2679271788f,
                        0.05248058142f,
                        0.04143203796f,
                        -0.01381067932f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.1767766953f,
                        0.5303300859f,
                        -0.5303300859f,
                        0.1767766953f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.1767766953f,
                        0.5303300859f,
                        0.5303300859f,
                        0.1767766953f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        -0.01381067932f,
                        -0.04143203796f,
                        0.05248058142f,
                        0.2679271788f,
                        -0.07181553246f,
                        -0.9667475524f,
                        0.9667475524f,
                        0.07181553246f,
                        -0.2679271788f,
                        -0.05248058142f,
                        0.04143203796f,
                        0.01381067932f);
                break;

            case bior37:
				filtLen = 16;
                lo_a = toArray(filtLen,
                        0.003021086101f,
                        -0.009063258304f,
                        -0.01683176542f,
                        0.07466398507f,
                        0.03133297871f,
                        -0.3011591259f,
                        -0.02649924095f,
                        0.9516421219f,
                        0.9516421219f,
                        -0.02649924095f,
                        -0.3011591259f,
                        0.03133297871f,
                        0.07466398507f,
                        -0.01683176542f,
                        -0.009063258304f,
                        0.003021086101f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.1767766953f,
                        0.5303300859f,
                        -0.5303300859f,
                        0.1767766953f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.1767766953f,
                        0.5303300859f,
                        0.5303300859f,
                        0.1767766953f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.003021086101f,
                        0.009063258304f,
                        -0.01683176542f,
                        -0.07466398507f,
                        0.03133297871f,
                        0.3011591259f,
                        -0.02649924095f,
                        -0.9516421219f,
                        0.9516421219f,
                        0.02649924095f,
                        -0.3011591259f,
                        -0.03133297871f,
                        0.07466398507f,
                        0.01683176542f,
                        -0.009063258304f,
                        -0.003021086101f);
                break;

            case bior39:
				filtLen = 20;
                lo_a = toArray(filtLen,
                        -0.0006797443728f,
                        0.002039233118f,
                        0.00506031922f,
                        -0.02061891264f,
                        -0.01411278793f,
                        0.09913478249f,
                        0.01230013627f,
                        -0.3201919684f,
                        0.002050022712f,
                        0.9421257007f,
                        0.9421257007f,
                        0.002050022712f,
                        -0.3201919684f,
                        0.01230013627f,
                        0.09913478249f,
                        -0.01411278793f,
                        -0.02061891264f,
                        0.00506031922f,
                        0.002039233118f,
                        -0.0006797443728f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.1767766953f,
                        0.5303300859f,
                        -0.5303300859f,
                        0.1767766953f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.1767766953f,
                        0.5303300859f,
                        0.5303300859f,
                        0.1767766953f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        -0.0006797443728f,
                        -0.002039233118f,
                        0.00506031922f,
                        0.02061891264f,
                        -0.01411278793f,
                        -0.09913478249f,
                        0.01230013627f,
                        0.3201919684f,
                        0.002050022712f,
                        -0.9421257007f,
                        0.9421257007f,
                        -0.002050022712f,
                        -0.3201919684f,
                        -0.01230013627f,
                        0.09913478249f,
                        0.01411278793f,
                        -0.02061891264f,
                        -0.00506031922f,
                        0.002039233118f,
                        0.0006797443728f);
                break;

            case bior44:
				filtLen = 10;
                lo_a = toArray(filtLen,
                        0.0f,
                        0.03782845551f,
                        -0.02384946502f,
                        -0.1106244044f,
                        0.3774028556f,
                        0.852698679f,
                        0.3774028556f,
                        -0.1106244044f,
                        -0.02384946502f,
                        0.03782845551f);
                hi_a = toArray(filtLen,
                        -0.0f,
                        -0.06453888263f,
                        0.04068941761f,
                        0.4180922732f,
                        -0.7884856164f,
                        0.4180922732f,
                        0.04068941761f,
                        -0.06453888263f,
                        -0.0f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.0f,
                        -0.06453888263f,
                        -0.04068941761f,
                        0.4180922732f,
                        0.7884856164f,
                        0.4180922732f,
                        -0.04068941761f,
                        -0.06453888263f,
                        0.0f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.0f,
                        -0.03782845551f,
                        -0.02384946502f,
                        0.1106244044f,
                        0.3774028556f,
                        -0.852698679f,
                        0.3774028556f,
                        0.1106244044f,
                        -0.02384946502f,
                        -0.03782845551f);
                break;

            case bior55:
				filtLen = 12;
                lo_a = toArray(filtLen,
                        0.0f,
                        0.0f,
                        0.03968708835f,
                        0.007948108637f,
                        -0.05446378847f,
                        0.345605282f,
                        0.7366601814f,
                        0.345605282f,
                        -0.05446378847f,
                        0.007948108637f,
                        0.03968708835f,
                        0.0f);
                hi_a = toArray(filtLen,
                        -0.01345670946f,
                        -0.00269496688f,
                        0.1367065847f,
                        -0.0935046974f,
                        -0.4768032658f,
                        0.8995061097f,
                        -0.4768032658f,
                        -0.0935046974f,
                        0.1367065847f,
                        -0.00269496688f,
                        -0.01345670946f,
                        0.0f);
                lo_r = toArray(filtLen,
                        0.01345670946f,
                        -0.00269496688f,
                        -0.1367065847f,
                        -0.0935046974f,
                        0.4768032658f,
                        0.8995061097f,
                        0.4768032658f,
                        -0.0935046974f,
                        -0.1367065847f,
                        -0.00269496688f,
                        0.01345670946f,
                        0.0f);
                hi_r = toArray(filtLen,
                        0.0f,
                        -0.0f,
                        0.03968708835f,
                        -0.007948108637f,
                        -0.05446378847f,
                        -0.345605282f,
                        0.7366601814f,
                        -0.345605282f,
                        -0.05446378847f,
                        -0.007948108637f,
                        0.03968708835f,
                        -0.0f);
                break;

            case bior68:
				filtLen = 18;
                lo_a = toArray(filtLen,
                        0.0f,
                        0.001908831736f,
                        -0.001914286129f,
                        -0.01699063987f,
                        0.01193456528f,
                        0.04973290349f,
                        -0.07726317317f,
                        -0.0940592035f,
                        0.4207962846f,
                        0.8259229975f,
                        0.4207962846f,
                        -0.0940592035f,
                        -0.07726317317f,
                        0.04973290349f,
                        0.01193456528f,
                        -0.01699063987f,
                        -0.001914286129f,
                        0.001908831736f);
                hi_a = toArray(filtLen,
                        0.0f,
                        -0.0f,
                        0.0f,
                        0.01442628251f,
                        -0.0144675049f,
                        -0.07872200106f,
                        0.04036797903f,
                        0.4178491092f,
                        -0.7589077295f,
                        0.4178491092f,
                        0.04036797903f,
                        -0.07872200106f,
                        -0.0144675049f,
                        0.01442628251f,
                        0.0f,
                        -0.0f,
                        0.0f,
                        -0.0f);
                lo_r = toArray(filtLen,
                        -0.0f,
                        -0.0f,
                        -0.0f,
                        0.01442628251f,
                        0.0144675049f,
                        -0.07872200106f,
                        -0.04036797903f,
                        0.4178491092f,
                        0.7589077295f,
                        0.4178491092f,
                        -0.04036797903f,
                        -0.07872200106f,
                        0.0144675049f,
                        0.01442628251f,
                        -0.0f,
                        -0.0f,
                        -0.0f,
                        -0.0f);
                hi_r = toArray(filtLen,
                        0.0f,
                        -0.001908831736f,
                        -0.001914286129f,
                        0.01699063987f,
                        0.01193456528f,
                        -0.04973290349f,
                        -0.07726317317f,
                        0.0940592035f,
                        0.4207962846f,
                        -0.8259229975f,
                        0.4207962846f,
                        0.0940592035f,
                        -0.07726317317f,
                        -0.04973290349f,
                        0.01193456528f,
                        0.01699063987f,
                        -0.001914286129f,
                        -0.001908831736f);
                break;
        }




}